JavaScript Data GridRow Selection

javascript logo

Select a row by clicking on it. Selecting a row will remove any previous selection unless you hold down ^ Ctrl while clicking. Selecting a row and holding down ⇧ Shift while clicking a second row will select the range.

Configure row selection with the following properties:

  • rowSelection: Type of row selection, set to either 'single' or 'multiple' to enable selection. 'single' will use single row selection, such that when you select a row, any previously selected row gets unselected. 'multiple' allows multiple rows to be selected.

  • rowMultiSelectWithClick: Set to true to allow multiple rows to be selected with clicks. For example, if you click to select one row and then click to select another row, the first row will stay selected as well. Clicking a selected row in this mode will deselect the row. This is useful for touch devices where ^ Ctrl and ⇧ Shift clicking is not an option.

  • suppressRowDeselection: Set to true to prevent rows from being deselected if you hold down ^ Ctrl and click the row (i.e. once a row is selected, it remains selected until another row is selected in its place). By default the grid allows deselection of rows.

  • suppressRowClickSelection: If true, rows won't be selected when clicked. Use, for example, when you want checkbox selection or your managing selection from a custom component and don't want to select the row when the row is clicked.

When you pass data to the grid, it wraps each data item in a node object. When you query for the selected rows, there are two method types: ones that return nodes, and ones that return data items. To get the selected nodes / rows from the grid, use the following API methods:

Working with AG Grid nodes is preferred over the row data as it provides you with more information and maps better to the internal representation of AG Grid.

Single Row Selection

  • Property rowSelection='single' is set to enable single row selection. It is not possible to select multiple rows.

Multiple Row Selection

  • Property rowSelection='multiple' is set to enable multiple row selection. Selecting multiple rows can be achieved by holding down ^ Ctrl and mouse clicking the rows. A range of rows can be selected by using ⇧ Shift.

Multi Select With Click

Clicking multiple rows will select a range of rows without the need for ^ Ctrl or ⇧ Shift keys. Clicking a selected row will deselect it. This is useful for touch devices where ^ Ctrl and ⇧ Shift clicks are not available.

  • Property rowMultiSelectWithClick=true is set to enable multiple row selection with clicks.
  • Clicking multiple rows will select multiple rows without needing to press ^ Ctrl or ⇧ Shift keys.
  • Clicking a selected row will deselect that row.

Checkbox Selection

Checkbox selection can be used in two places: row selection and group selection.

To include checkbox selection for a column, set the attribute 'checkboxSelection' to true on the column definition. You can set this attribute on as many columns as you like, however it doesn't make sense to have it in more than one column in a table.

To enable checkbox selection for groups, set the attribute 'checkbox' to true for the group renderer. See the grouping section for details on the group renderer.

checkboxSelection can also be specified as a function. This allows dynamically setting whether a cell has a checkbox or not. The callback is called when the Cell is drawn, and called again if there are any changes to the row's data or the column positions (e.g. the callback could be showing the checkbox depending on what value is displayed, or if the column in question is the first column to show a checkbox for the first column only).

If the function returns false, a selection checkbox will still be created and in the DOM, however it will not be visible using CSS visibility: hidden. This is to ensure the following UX properties:

  1. Where a column has a checkbox for only some cells, the values will remain aligned.
  2. When a checkbox visibility changes, the cells contents don't jump.

To be clear, there is a slight difference between a callback returning false, and false value provided explicitly. When a callback is used and returns false, the grid assumes a checkbox is sometimes used and as such creates one that is not visible.

// do not create checkbox
colDef.checkboxSelection = false;

// create checkbox, make checkbox not visible
colDef.checkboxSelection = () => false;

Displaying Disabled Checkboxes

It is possible to change the default behaviour for when a checkbox is not displayed, and instead have the checkbox visible but disabled. This can be done by enabling the column property showDisabledCheckboxes.

Forcing Checkboxes As Selected

It is possible to select a row via API and disable its checkbox to prevent users from de-selecting it. This can be achieved by providing a predicate to the checkboxSelection property which will determine whether a row’s checkbox is selectable or disabled.

In the example below please note that only rows with Year=2012 are selectable. All remaining rows have disabled checkboxes and cannot be selected by the user.

Please note that clicking the header checkbox selects all rows even if their checkboxes are disabled.

Group Selection

When doing grouping, you control what selecting a group means. This is controlled with the two grid properties groupSelectsChildren and groupSelectsFiltered.

  • groupSelectsChildren: When true, selecting a group will have the impact of selecting all its children. The group will then display 'selected' when all children are selected, 'unselected' when none are selected and 'intermediate' when children have a mix of selected and unselected. When the node is selecting children, it will never appear in the selected set when calling api.getSelectedNodes().
    When false, the group is selectable independently of the child nodes. When selecting the group node independently of the children, it will appear in the set when calling api.getSelectedNodes().

  • groupSelectsFiltered: Used when groupSelectsChildren=true. When true only filtered children of the group will be selected / unselected. This means you can apply a filter, then try to select a group, and the group will end up in the intermediate state as only as subset of the children will be selected.

Groups & Checkbox Selection

Selecting the group has the effect of selecting the children. Likewise selecting all the children automatically selects the group. In this scenario the group itself will never appear in the selectedRows list.

The example also shows a checkbox for selection on the age column. In practice, it is not normal to have more than one column for selection, the below is just for demonstration. Having a checkbox within a non-group row is best for grids that are not using grouping.

Groups & Checkbox Selection With Unselectable Leaf Nodes

The example below is similar to the previous example except it does not put checkboxes on the leaf level nodes, allowing only entire groups to be selected. This is achieved by providing functions for colDef.checkboxSelection and autoGroupColumnDef.cellRendererParams.checkbox.

Groups & Checkbox Selection With Only Filtered Children

Lastly we show an example using groupSelectsFiltered=true. Here, when you filter the grid and select a group, only the filtered children get selected.

To demonstrate, try this in the example:

  1. Filter on swimming
  2. Select a country
  3. Notice that all filtered rows get selected. If you remove the filter, the non-filtered rows are not selected.
  4. Notice that the group checkbox becomes indeterminate while all its filtered children get selected. This is because the selected state of the group node is independent to the filter, so it becomes indeterminate as not all of its children are selected.

Header Checkbox Selection

It is possible to have a checkbox in the header for selection. To configure the column to have a header checkbox, set colDef.headerCheckboxSelection=true. headerCheckboxSelection can also be a function, if you want the header checkbox to appear sometimes (e.g. if the column is ordered first in the grid).

const gridOptions = {
    columnDefs: [
        // the name column header always has a checkbox in the header
        {
            field: 'name',
            headerCheckboxSelection: true
        },
        // the country column header only has checkbox if it is the first column
        {
            field: 'country',
            headerCheckboxSelection: params => {
                const displayedColumns = params.api.getAllDisplayedColumns();
                return displayedColumns[0] === params.column;
            }
        },
    ],

    // other grid options ...
}

If headerCheckboxSelection is a function, the function will be called every time there is a change to the displayed columns, to check for changes.

Select Everything or Just Filtered

The header checkbox has three modes of operation, 'normal', 'filtered only' and 'current page'.

  • colDef.headerCheckboxSelectionFilteredOnly=false: The header checkbox will select all rows when checked, and un-select all rows when unchecked. The header checkbox will update its state based on all rows.

  • colDef.headerCheckboxSelectionFilteredOnly=true: The header checkbox will select only filtered rows when checked and un-select only filtered rows when unchecked. The header checkbox will update its state based only on filtered rows.

  • colDef.headerCheckboxSelectionCurrentPageOnly=true: The header checkbox will select only the rows on the current page when checked, and un-select only the rows on the current page when unchecked.

The examples below demonstrate all of these options.

Just Filtered

This example has the following characteristics:

  • The header checkbox works on filtered rows only. That means if you filter first, then hit the header checkbox to select or un-select, then only the filtered rows are affected.

  • The header checkbox is always on the athlete column, even if the athlete column is moved.

Select Everything

The next example is similar to the one above with the following changes:

  • The header checkbox selects everything, not just filtered.
  • The column that the selection header checkbox appears in is always the first column. This can be observed by dragging the columns to reorder them.

Select Only the Current Page

The next example demonstrates the headerCheckboxSelectionCurrentPageOnly property, note the following:

  • The header checkbox selects collapsed groups and all of their children.
  • The header checkbox will select expanded group nodes, but only the children which are also on the current page.

Current Page with Group Selects Children

The next example demonstrates the headerCheckboxSelectionCurrentPageOnly property while using groupSelectsChildren, note the following:

  • The header checkbox selects collapsed groups and all of their children.
  • The header checkbox will select expanded group nodes only if all of the children are selected, otherwise they will become indeterminate.

Specify Selectable Rows

It is possible to specify which rows can be selected via the gridOptions.isRowSelectable(rowNode) callback function.

For instance if we only wanted to allow rows where the 'year' property is less than 2007, we could implement the following:

const gridOptions = {
    isRowSelectable: rowNode => rowNode.data ? rowNode.data.year < 2007 : false,

    // other grid options ...
}

Selectable Rows with Header Checkbox

This example demonstrates the following:

  • The isRowSelectable(node) callback only allows selections on rows where the year < 2007.
  • The country column has headerCheckboxSelection: true and checkboxSelection: true, but only rows which are selectable will obtain a selectable checkbox. Similarly, the header checkbox will only select selectable rows.

Specifying Selectable Rows with Groups

This example demonstrates the following:

  • The isRowSelectable(node) callback allows rows with a year of 2004 or 2008 to be selectable.

  • As gridOptions.groupSelectsChildren = true selecting groups will also select 'selectable' children.

  • As gridOptions.groupSelectsFiltered = true selecting groups will only select 'selectable' children that pass the filter.

  • To demonstrate, follow these steps:

    1. Click 'Filter by Year 2008 & 2012'.
    2. Select checkbox beside 'United States'.
    3. Click 'Clear Filter'.
    4. Notice that only 'United States' for 2008 is selected.

Selection Events

There are two events with regards to selection:

Node Selection API

To select rows programmatically, use the node.setSelected(params) method.

// set selected, keep any other selections
node.setSelected(true);

// set selected, exclusively, remove any other selections
node.setSelected(true, true);

// un-select
node.setSelected(false);

// check status of node selection
const selected = node.isSelected();

The isSelected() method returns true if the node is selected, or false if it is not selected. If the node is a group node and the group selection is set to 'children', this will return true if all child (and grandchild) nodes are selected, false if all unselected, or undefined if a mixture.

Grid Selection API

The grid API has the following methods for selection:

If you want to select only the filtered rows, you could do this using the following:

// loop through each node after filter
const nodes = [];
api.forEachNodeAfterFilter(node => {
   nodes.push(node);
});
api.setNodesSelected({ nodes, newValue: true });

Using forEachNode

The Grid API function forEachNode can be used to select grid rows based on a business key. The example below shows selecting all rows with country = 'United States'. This method is also useful when you load data and need to know the node equivalent of the data for selection purposes.

Selection with Keyboard Arrow Keys

By default, you can select a row on mouse click, and navigate up and down the rows using your keyboard keys. However, the selection state does not correlate with the navigation keys, but we can add this behaviour using our own Custom Navigation.

We need to provide a callback to the navigateToNextCell grid option to override the default arrow key navigation:

const gridOptions = {
    navigateToNextCell: params => {
        const suggestedNextCell = params.nextCellPosition;

        // this is some code
        const KEY_UP = 'ArrowUp';
        const KEY_DOWN = 'ArrowDown';

        const noUpOrDownKey = params.key !== KEY_DOWN && params.key !== KEY_UP;
        if (noUpOrDownKey) {
            return suggestedNextCell;
        }

        params.api.forEachNode(node => {
            if (node.rowIndex === suggestedNextCell.rowIndex) {
                node.setSelected(true);
            }
        });

        return suggestedNextCell;
    },

    // other grid options ...
}

From the code above you can see that we iterate over each node and call the setSelected() method if it matches the current rowIndex.

---
product: "AG Grid"
title: "Row Selection"
description: "Configure row selection, checkbox selection, and group selection in the Angular Table. Single row selection, multiple row selection, and multi select with click."
framework: angular
version: "36.2.0"
related:
    - title: "Cell Selection"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/cell-selection/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Row Selection

Configure the grid to allow users to select rows by clicking them, focusing a row and pressing `␣ Space` or via API.

## Enabling Row Selection

Row selection is configured with the `rowSelection` grid property. Setting `rowSelection.mode` to either `'multiRow'` or `'singleRow'` will allow you to select rows by clicking, focusing a row and pressing `␣ Space`, or via the selection API.

```ts
<ag-grid-angular
    [rowSelection]="rowSelection"
    /* other grid options ... */ />

this.rowSelection = {
    mode: 'singleRow',
};
```

The following example illustrates a basic row selection configuration. Use the select control to choose the default single row or multi-row configuration.

See detailed documentation on the two row selection modes:

- [Single Row Selection](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/row-selection-single-row/)
- [Multi-Row Selection](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/row-selection-multi-row/)

#### Enabling Row Selection

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  RowSelectionMode,
  RowSelectionModule,
  RowSelectionOptions,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  RowGroupingModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  RowSelectionModule,
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  RowGroupingModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="example-wrapper">
    <div class="example-header">
      <label>
        <span>Selection mode: </span>
        <select id="input-selection-mode" (change)="updateSelectionOptions()">
          <option value="singleRow">singleRow</option>
          <option value="multiRow">multiRow</option>
        </select>
      </label>
    </div>
    <ag-grid-angular
      style="width: 100%; height: 100%;"
      [columnDefs]="columnDefs"
      [defaultColDef]="defaultColDef"
      [rowSelection]="rowSelection"
      [rowData]="rowData"
      (gridReady)="onGridReady($event)"
    />
  </div> `,
})
export class AppComponent {
  private gridApi!: GridApi<IOlympicData>;

  columnDefs: ColDef[] = [
    { field: "athlete", minWidth: 150 },
    { field: "age", maxWidth: 90 },
    { field: "country", minWidth: 150 },
    { field: "year", maxWidth: 90 },
    { field: "date", minWidth: 150 },
    { field: "sport", minWidth: 150 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 100,
  };
  rowSelection: RowSelectionOptions | "single" | "multiple" = {
    mode: "singleRow",
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  updateSelectionOptions() {
    this.gridApi.setGridOption("rowSelection", {
      mode: getSelectValue("#input-selection-mode"),
    });
  }

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.gridApi = params.api;

    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}

function getSelectValue(id: string): RowSelectionMode {
  return (
    (document.querySelector<HTMLSelectElement>(id)
      ?.value as RowSelectionMode) ?? "singleRow"
  );
}
```

[Live example: Enabling Row Selection](https://www.ag-grid.com/archive/36.2.0/examples/row-selection/enabling-row-selection/angular/)

## Row Selection with Enterprise Features

Row selection can be used when using row grouping, tree data and the server-side row model. See the respective sections of the documentation:

- [Row Group Selection](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/grouping-row-selection/)
- [Tree Data Selection](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/tree-data-selection/)
- [Server-Side Row Model Selection](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/server-side-model-selection/)


---
product: "AG Grid"
title: "Row Selection"
description: "Configure row selection, checkbox selection, and group selection in the React Table. Single row selection, multiple row selection, and multi select with click."
framework: react
version: "36.2.0"
related:
    - title: "Cell Selection"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/cell-selection/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Row Selection

Configure the grid to allow users to select rows by clicking them, focusing a row and pressing `␣ Space` or via API.

## Enabling Row Selection

Row selection is configured with the `rowSelection` grid property. Setting `rowSelection.mode` to either `'multiRow'` or `'singleRow'` will allow you to select rows by clicking, focusing a row and pressing `␣ Space`, or via the selection API.

```jsx
const rowSelection = useMemo(() => { 
	return {
        mode: 'singleRow',
    };
}, []);

<AgGridReact rowSelection={rowSelection} />
```

The following example illustrates a basic row selection configuration. Use the select control to choose the default single row or multi-row configuration.

See detailed documentation on the two row selection modes:

- [Single Row Selection](https://www.ag-grid.com/archive/36.2.0/react-data-grid/row-selection-single-row/)
- [Multi-Row Selection](https://www.ag-grid.com/archive/36.2.0/react-data-grid/row-selection-multi-row/)

#### Enabling Row Selection

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  RowSelectionMode,
  RowSelectionModule,
  RowSelectionOptions,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  RowGroupingModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  RowSelectionModule,
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  RowGroupingModule,
];

const getSelectValue: (id: string) => RowSelectionMode = (id: string) => {
  return (
    (document.querySelector<HTMLSelectElement>(id)
      ?.value as RowSelectionMode) ?? "singleRow"
  );
};

const GridExample = () => {
  const gridRef = useRef<AgGridReact<IOlympicData>>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete", minWidth: 150 },
    { field: "age", maxWidth: 90 },
    { field: "country", minWidth: 150 },
    { field: "year", maxWidth: 90 },
    { field: "date", minWidth: 150 },
    { field: "sport", minWidth: 150 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 100,
    };
  }, []);
  const rowSelection = useMemo<
    RowSelectionOptions | "single" | "multiple"
  >(() => {
    return {
      mode: "singleRow",
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/small-olympic-winners.json",
  );

  const updateSelectionOptions = useCallback(() => {
    gridRef.current!.api.setGridOption("rowSelection", {
      mode: getSelectValue("#input-selection-mode"),
    });
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="example-wrapper">
          <div className="example-header">
            <label>
              <span>Selection mode: </span>
              <select
                id="input-selection-mode"
                onChange={updateSelectionOptions}
              >
                <option value="singleRow">singleRow</option>
                <option value="multiRow">multiRow</option>
              </select>
            </label>
          </div>

          <div style={gridStyle}>
            <AgGridReact<IOlympicData>
              ref={gridRef}
              rowData={data}
              loading={loading}
              columnDefs={columnDefs}
              defaultColDef={defaultColDef}
              rowSelection={rowSelection}
            />
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Enabling Row Selection](https://www.ag-grid.com/archive/36.2.0/examples/row-selection/enabling-row-selection/reactFunctionalTs/)

## Row Selection with Enterprise Features

Row selection can be used when using row grouping, tree data and the server-side row model. See the respective sections of the documentation:

- [Row Group Selection](https://www.ag-grid.com/archive/36.2.0/react-data-grid/grouping-row-selection/)
- [Tree Data Selection](https://www.ag-grid.com/archive/36.2.0/react-data-grid/tree-data-selection/)
- [Server-Side Row Model Selection](https://www.ag-grid.com/archive/36.2.0/react-data-grid/server-side-model-selection/)


---
product: "AG Grid"
title: "Row Selection"
description: "Configure row selection, checkbox selection, and group selection in the Vue Table. Single row selection, multiple row selection, and multi select with click."
framework: vue
version: "36.2.0"
related:
    - title: "Cell Selection"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/cell-selection/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Row Selection

Configure the grid to allow users to select rows by clicking them, focusing a row and pressing `␣ Space` or via API.

## Enabling Row Selection

Row selection is configured with the `rowSelection` grid property. Setting `rowSelection.mode` to either `'multiRow'` or `'singleRow'` will allow you to select rows by clicking, focusing a row and pressing `␣ Space`, or via the selection API.

```ts
<ag-grid-vue
    :rowSelection="rowSelection"
    /* other grid options ... */>
</ag-grid-vue>

this.rowSelection = {
    mode: 'singleRow',
};
```

The following example illustrates a basic row selection configuration. Use the select control to choose the default single row or multi-row configuration.

See detailed documentation on the two row selection modes:

- [Single Row Selection](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/row-selection-single-row/)
- [Multi-Row Selection](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/row-selection-multi-row/)

#### Enabling Row Selection

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  RowSelectionMode,
  RowSelectionModule,
  RowSelectionOptions,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  RowGroupingModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  RowSelectionModule,
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  RowGroupingModule,
]);

function getSelectValue(id: string): RowSelectionMode {
  return (
    (document.querySelector<HTMLSelectElement>(id)
      ?.value as RowSelectionMode) ?? "singleRow"
  );
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="example-wrapper">
      <div class="example-header">
        <label>
          <span>Selection mode: </span>
          <select id="input-selection-mode" v-on:change="updateSelectionOptions()">
            <option value="singleRow">singleRow</option>
            <option value="multiRow">multiRow</option>
          </select>
        </label>
      </div>
      <ag-grid-vue
        style="width: 100%; height: 100%;"
        @grid-ready="onGridReady"
        :columnDefs="columnDefs"
        :defaultColDef="defaultColDef"
        :rowSelection="rowSelection"
        :rowData="rowData"></ag-grid-vue>
      </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete", minWidth: 150 },
      { field: "age", maxWidth: 90 },
      { field: "country", minWidth: 150 },
      { field: "year", maxWidth: 90 },
      { field: "date", minWidth: 150 },
      { field: "sport", minWidth: 150 },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
      { field: "total" },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 100,
    });
    const rowSelection = ref<RowSelectionOptions | "single" | "multiple">({
      mode: "singleRow",
    });
    const rowData = ref<IOlympicData[]>(null);

    function updateSelectionOptions() {
      gridApi.value.setGridOption("rowSelection", {
        mode: getSelectValue("#input-selection-mode"),
      });
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      rowSelection,
      rowData,
      onGridReady,
      updateSelectionOptions,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Enabling Row Selection](https://www.ag-grid.com/archive/36.2.0/examples/row-selection/enabling-row-selection/vue3/)

## Row Selection with Enterprise Features

Row selection can be used when using row grouping, tree data and the server-side row model. See the respective sections of the documentation:

- [Row Group Selection](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/grouping-row-selection/)
- [Tree Data Selection](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/tree-data-selection/)
- [Server-Side Row Model Selection](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/server-side-model-selection/)
